## treeland 0.5.20

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25.0)

project(Treeland
    VERSION 0.2.2
    LANGUAGES CXX C)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Standard installation paths
include(GNUInstallDirs)
# Macros
include(FeatureSummary)

include(cmake/DefineTarget.cmake)

option(WITH_SUBMODULE_WAYLIB "Use the waylib from git submodule" OFF)
add_feature_info(submodule_waylib WITH_SUBMODULE_WAYLIB "Use waylib from submodule")

option(ADDRESS_SANITIZER "Enable address sanitize" OFF)
add_feature_info(ASanSupport ADDRESS_SANITIZER "https://github.com/google/sanitizers/wiki/AddressSanitizer")

option(BUILD_TREELAND_EXAMPLES "Build clients demo to test treeland" OFF)
add_feature_info(DemoClents BUILD_TEST_CLIENTS "clients demo for testing")

option(DISABLE_DDM "Disable DDM and greeter" OFF)

if (DISABLE_DDM)
    add_compile_definitions("DISABLE_DDM")
endif()

if (ADDRESS_SANITIZER)
    add_compile_options(-fsanitize=address -fno-optimize-sibling-calls -fno-omit-frame-pointer)
    add_link_options(-fsanitize=address)
endif()

set(LOCAL_QML_IMPORT_PATH "${PROJECT_BINARY_DIR}/qt/qml")

if(WITH_SUBMODULE_WAYLIB)
    set(WITH_SUBMODULE_QWLROOTS ON)
    include(${CMAKE_CURRENT_SOURCE_DIR}/waylib/qwlroots/cmake/WaylandScannerHelpers.cmake)
    add_subdirectory(waylib)
    list(APPEND LOCAL_QML_IMPORT_PATH "${PROJECT_BINARY_DIR}/waylib/src/server")
else()
    find_package(Waylib REQUIRED Server)
endif()

set(QML_IMPORT_PATH "${LOCAL_QML_IMPORT_PATH}" CACHE STRING "For LSP" FORCE)

# PKG-CONFIG
find_package(PkgConfig REQUIRED)
find_package(Qt6 CONFIG REQUIRED Core DBus Gui Qml Quick QuickControls2 LinguistTools Test QuickTest)

set(wlr wlroots-0.18)
set(WLROOTS_MINIMUM_REQUIRED 0.18.0)
pkg_check_modules(WLROOTS REQUIRED IMPORTED_TARGET ${wlr}>=${WLROOTS_MINIMUM_REQUIRED})

qt_standard_project_setup(REQUIRES 6.8)

# Set constants
set(TREELAND_DATA_DIR           "${CMAKE_INSTALL_DATADIR}/treeland/"               CACHE PATH      "treeland data install directory")
set(TREELAND_COMPONENTS_TRANSLATION_DIR  "${TREELAND_DATA_DIR}/translations"                  CACHE PATH      "Components translations directory")
set(TREELAND_PLUGINS_OUTPUT_PATH   "${CMAKE_BINARY_DIR}/lib/plugins"          CACHE PATH      "treeland plugins output directory")
set(TREELAND_PLUGINS_INSTALL_PATH  "${CMAKE_INSTALL_LIBDIR}/treeland/plugins" CACHE PATH      "treeland plugins install directory")

GNUInstallDirs_get_absolute_install_dir(
    TREELAND_FULL_DATA_DIR
    TREELAND_DATA_DIR
    DATADIR
)

GNUInstallDirs_get_absolute_install_dir(
    TREELAND_FULL_PLUGINS_INSTALL_PATH
    TREELAND_PLUGINS_INSTALL_PATH
    LIBDIR
)

GNUInstallDirs_get_absolute_install_dir(
    TREELAND_FULL_COMPONENTS_TRANSLATION_DIR
    TREELAND_COMPONENTS_TRANSLATION_DIR
    DATADIR
)

add_compile_definitions("TREELAND_DATA_DIR=\"${TREELAND_FULL_DATA_DIR}\"")
# NOTE:: remove force assert before stable version
add_compile_definitions("QT_FORCE_ASSERTS")

add_compile_definitions("TREELAND_PLUGINS_INSTALL_PATH=\"${TREELAND_FULL_PLUGINS_INSTALL_PATH}\"")
add_compile_definitions("TREELAND_PLUGINS_OUTPUT_PATH=\"${TREELAND_PLUGINS_OUTPUT_PATH}\"")

add_compile_definitions("TREELAND_COMPONENTS_TRANSLATION_DIR=\"${TREELAND_FULL_COMPONENTS_TRANSLATION_DIR}\"")

set(PROJECT_RESOURCES_DIR "${CMAKE_SOURCE_DIR}/misc")

enable_testing(true)

add_subdirectory(src)
add_subdirectory(misc)
add_subdirectory(tests)

if (BUILD_TREELAND_EXAMPLES)
    add_subdirectory(examples)
endif()

# Display feature summary
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== misc/CMakeLists.txt ===
add_subdirectory(dbus)
add_subdirectory(dconfig)
add_subdirectory(systemd)
add_subdirectory(wayland-sessions)
add_subdirectory(portal)
add_subdirectory(polkit-1)
add_subdirectory(cmake)

=== src/CMakeLists.txt ===
if(QT_KNOWN_POLICY_QTP0001)
    qt_policy(SET QTP0001 NEW)
    # the RESOURCE_PREFIX argument for qt_add_qml_module() defaults to ":/qt/qml/"
endif()
if(POLICY CMP0071)
    # https://cmake.org/cmake/help/latest/policy/CMP0071.html
    cmake_policy(SET CMP0071 NEW)
endif()

find_package(Dtk6 REQUIRED COMPONENTS Core Declarative SystemSettings)
if (NOT DISABLE_DDM)
    find_package(DDM REQUIRED COMPONENTS Auth Common)
endif()
find_package(QT NAMES Qt6 COMPONENTS Core REQUIRED)
find_package(Qt6 CONFIG REQUIRED ShaderTools Concurrent)
find_package(Qt6 COMPONENTS Quick QuickControls2 REQUIRED)
pkg_search_module(PIXMAN REQUIRED IMPORTED_TARGET pixman-1)
pkg_search_module(WAYLAND REQUIRED IMPORTED_TARGET wayland-server)
pkg_search_module(LIBINPUT REQUIRED IMPORTED_TARGET libinput)
pkg_search_module(XCB REQUIRED IMPORTED_TARGET xcb)
pkg_check_modules(PAM REQUIRED IMPORTED_TARGET pam)
pkg_check_modules(JEMALLOC REQUIRED IMPORTED_TARGET jemalloc)
# qt_finalize_target will collect all executable's private dependencies that are CMake targets

qt_add_dbus_adaptor(DBUS_ADAPTOR "${CMAKE_SOURCE_DIR}/misc/dbus/org.deepin.compositor1.xml" "core/treeland.h" Treeland::Treeland)

set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.xml" PROPERTIES
    NO_NAMESPACE ON
    CLASSNAME DisplayManager
)
set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.Seat.xml" PROPERTIES
    NO_NAMESPACE ON
    CLASSNAME DisplaySeat
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.Session.xml" PROPERTIES
    NO_NAMESPACE ON
    CLASSNAME DisplaySession
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Manager.xml" PROPERTIES
   INCLUDE "loginddbustypes.h"
)
set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Seat.xml" PROPERTIES
   INCLUDE "loginddbustypes.h"
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Session.xml" PROPERTIES
   INCLUDE "loginddbustypes.h"
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.User.xml" PROPERTIES
   INCLUDE "loginddbustypes.h"
)

qt_add_dbus_interface(DDM_DBUS_SOURCES "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.xml"          DisplayManager)
qt_add_dbus_interface(DDM_DBUS_SOURCES "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.Seat.xml"     DisplayManagerSeat)
qt_add_dbus_interface(DDM_DBUS_SOURCES "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.Session.xml"  DisplayManagerSession)
qt_add_dbus_interface(DDM_DBUS_SOURCES "${CMAKE_SOURCE_DIR}/misc/interfaces/org.deepin.DisplayManager.xml"               DDMDisplayManager)
qt_add_dbus_interface(DBUS_INTERFACE   "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Manager.xml"          Login1Manager)
qt_add_dbus_interface(DBUS_INTERFACE   "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Seat.xml"             Login1Seat)
qt_add_dbus_interface(DBUS_INTERFACE   "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Session.xml"          Login1Session)
qt_add_dbus_interface(DBUS_INTERFACE   "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.User.xml"             Login1User)

qt_add_library(libtreeland SHARED)

set_target_properties(libtreeland PROPERTIES
    OUTPUT_NAME "treeland"
)

qt_add_qml_module(libtreeland
    URI Treeland
    VERSION "2.0"

    SOURCES
        ${DBUS_ADAPTOR}
        ${DDM_DBUS_SOURCES}
        ${DBUS_INTERFACE}
        config/treelandconfig.cpp
        config/treelandconfig.h
        core/layersurfacecontainer.cpp
        core/layersurfacecontainer.h
        core/qmlengine.cpp
        core/qmlengine.h
        core/rootsurfacecontainer.cpp
        core/rootsurfacecontainer.h
        core/shellhandler.cpp
        core/shellhandler.h
        core/treeland.cpp
        core/treeland.h
        core/windowpicker.cpp
        core/windowpicker.h
        effects/tquickradiuseffect.cpp
        effects/tquickradiuseffect.h
        effects/tquickradiuseffect_p.h
        effects/tsgradiusimagenode.cpp
        effects/tsgradiusimagenode.h
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:core/lockscreen.h>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:core/lockscreen.cpp>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/global.h>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/greeterproxy.cpp>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/greeterproxy.h>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/sessionmodel.cpp>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/sessionmodel.h>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/user.cpp>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/user.h>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/usermodel.cpp>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/usermodel.h>
        input/gestures.cpp
        input/gestures.h
        input/inputdevice.cpp
        input/inputdevice.h
        input/togglablegesture.cpp
        input/togglablegesture.h
        interfaces/baseplugininterface.h
        interfaces/lockscreeninterface.h
        interfaces/multitaskviewinterface.h
        interfaces/plugininterface.h
        interfaces/proxyinterface.h
        output/output.cpp
        output/output.h
        seat/helper.cpp
        seat/helper.h
        surface/surfacecontainer.cpp
        surface/surfacecontainer.h
        surface/surfacefilterproxymodel.cpp
        surface/surfacefilterproxymodel.h
        surface/surfaceproxy.cpp
        surface/surfaceproxy.h
        surface/surfacewrapper.cpp
        surface/surfacewrapper.h
        utils/cmdline.cpp
        utils/cmdline.h
        utils/propertymonitor.cpp
        utils/propertymonitor.h
        utils/loginddbustypes.h
        utils/loginddbustypes.cpp
        wallpaper/wallpapercontroller.cpp
        wallpaper/wallpapercontroller.h
        wallpaper/wallpaperimage.cpp
        wallpaper/wallpaperimage.h
        wallpaper/wallpapermanager.cpp
        wallpaper/wallpapermanager.h
        workspace/workspace.cpp
        workspace/workspace.h
        workspace/workspaceanimationcontroller.cpp
        workspace/workspaceanimationcontroller.h
        workspace/workspacemodel.cpp
        workspace/workspacemodel.h

    QML_FILES
        core/qml/PrimaryOutput.qml
        core/qml/CopyOutput.qml
        core/qml/TitleBar.qml
        core/qml/Decoration.qml
        core/qml/WindowMenu.qml
        core/qml/TaskBar.qml
        core/qml/SurfaceContent.qml
        core/qml/XdgShadow.qml
        core/qml/Border.qml
        core/qml/OutputMenuBar.qml
        core/qml/WorkspaceSwitcher.qml
        core/qml/WorkspaceProxy.qml
        core/qml/Animations/GeometryAnimation.qml
        core/qml/Animations/NewAnimation.qml
        core/qml/Animations/MinimizeAnimation.qml
        core/qml/Animations/ShowDesktopAnimation.qml
        core/qml/Animations/LaunchpadAnimation.qml
        core/qml/Animations/LayerShellAnimation.qml
        core/qml/Effects/Blur.qml
        core/qml/Effects/LaunchpadCover.qml
        core/qml/TaskSwitcher.qml
        core/qml/TaskWindowPreview.qml
        core/qml/SwitchViewDelegate.qml
        core/qml/SwitchViewHighlightDelegate.qml
        core/qml/DockPreview.qml
        core/qml/FadeBehavior.qml
        core/qml/CaptureSelectorLayer.qml
        core/qml/WindowPickerLayer.qml
    RESOURCE_PREFIX
        /qt/qml
    OUTPUT_DIRECTORY
        ${PROJECT_BINARY_DIR}/qt/qml/Treeland
)

target_compile_definitions(libtreeland
    PRIVATE
    WLR_USE_UNSTABLE
)

qt_add_shaders(libtreeland "treeland_shaders_ng"
    BATCHABLE
    PRECOMPILE
    PREFIX
        "/shaders"
    BASE
        ${PROJECT_RESOURCES_DIR}/shaders
    FILES
        ${PROJECT_RESOURCES_DIR}/shaders/radiussmoothtexture.vert
        ${PROJECT_RESOURCES_DIR}/shaders/radiussmoothtexture.frag
)

qt_add_resources(libtreeland "treeland_assets"
    PREFIX "/dsg/icons"
    BASE ${PROJECT_RESOURCES_DIR}/icons
    FILES
        ${PROJECT_RESOURCES_DIR}/icons/close.dci
        ${PROJECT_RESOURCES_DIR}/icons/add.dci
        ${PROJECT_RESOURCES_DIR}/icons/select_output.dci
        ${PROJECT_RESOURCES_DIR}/icons/select_window.dci
        ${PROJECT_RESOURCES_DIR}/icons/select_region.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_capslock.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_display_password.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_hidden_password.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_keyboard.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_lock.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_open.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_power.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_reboot.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_hibernate.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_user.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_hint.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_logout.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_shutdown.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_suspend.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_switchuser.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_update_reboot.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_update_shutdown.dci
        ${PROJECT_RESOURCES_DIR}/icons/backToLightdm.dci
        ${PROJECT_RESOURCES_DIR}/icons/logo.svg
)

set(TRANSLATED_FILES)
qt_add_lupdate(
    SOURCE_TARGETS libtreeland
    TS_FILES
        ${CMAKE_SOURCE_DIR}/translations/treeland.zh_CN.ts
        ${CMAKE_SOURCE_DIR}/translations/treeland.en_US.ts
    NO_GLOBAL_TARGET
)
qt_add_lrelease(
    TS_FILES
        ${CMAKE_SOURCE_DIR}/translations/treeland.zh_CN.ts
        ${CMAKE_SOURCE_DIR}/translations/treeland.en_US.ts
    QM_FILES_OUTPUT_VARIABLE TRANSLATED_FILES
)

target_include_directories(libtreeland
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>
        $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/src>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/config>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/core>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/effects>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/greeter>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/input>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/interfaces>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/output>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/seat>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/surface>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/workspace>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/utils>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/wallpaper>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/treeland>
)

target_link_libraries(libtreeland
    PUBLIC
        Dtk6::Core
        Dtk6::Declarative
        Dtk6::SystemSettings
        Waylib::WaylibServer
    PRIVATE
        Qt6::Quick
        Qt6::QuickControls2
        Qt6::QuickPrivate
        Qt6::DBus
        Qt6::Concurrent
        PkgConfig::PIXMAN
        PkgConfig::WAYLAND
        PkgConfig::LIBINPUT
        PkgConfig::JEMALLOC
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:DDM::Auth>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:DDM::Common>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:PkgConfig::PAM>
)

add_subdirectory(plugins)
add_subdirectory(modules)
add_subdirectory(treeland-shortcut)

set(BIN_NAME treeland)

qt_add_executable(${BIN_NAME}
    main.cpp
)

target_include_directories(${BIN_NAME} PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/core/>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/interfaces/>
)

target_link_libraries(${BIN_NAME} PRIVATE
    libtreeland
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
install(PROGRAMS treeland.sh DESTINATION "${CMAKE_INSTALL_BINDIR}")
install(TARGETS libtreeland LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
# TODO: The qml plugin installation directory still needs to be adjusted

=== waylib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

project(Waylib
    VERSION 0.1.1
    LANGUAGES CXX C)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

option(WITH_SUBMODULE_QWLROOTS "Use the QWlroots from git submodule" OFF)
option(BUILD_EXAMPLES "A minimum viable product Wayland compositor based on waylib and other examples" ON)
option(BUILD_TESTS "Build test demos" ON)
option(DISABLE_XWAYLAND "Disable the xwayland support" OFF)
# Don't install tinywl by default, using for debug in local
option(INSTALL_TINYWL "A minimum viable product Wayland compositor based on waylib" OFF)
option(ADDRESS_SANITIZER "Enable address sanitize" OFF)
option(WAYLIB_USE_PERCOMPILE_HEADERS "Use precompile headers to build waylib" OFF)

set(QT_COMPONENTS Core Gui Quick)
find_package(Qt6 COMPONENTS ${QT_COMPONENTS} REQUIRED)
if(WITH_SUBMODULE_QWLROOTS)
    include(${CMAKE_CURRENT_SOURCE_DIR}/qwlroots/cmake/WaylandScannerHelpers.cmake)
    add_subdirectory(qwlroots)
    message("Using QWlroots from submodule")
else()
    find_package(QWlroots REQUIRED)
endif()

if(DISABLE_XWAYLAND)
    add_definitions(-DDISABLE_XWAYLAND)
endif()

if (ADDRESS_SANITIZER)
    add_compile_options(-fsanitize=address -fno-optimize-sibling-calls -fno-omit-frame-pointer)
    add_link_options(-fsanitize=address)
endif()

# For Unix/Linux
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
include(PackageVersionHelper)

add_subdirectory(src)
if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()
if(BUILD_TESTS)
    enable_testing(true)
    add_subdirectory(tests)
endif()

=== examples/test_capture/CMakeLists.txt ===
find_package(PkgConfig REQUIRED)
find_package(Qt6 REQUIRED COMPONENTS Core Gui WaylandClient Quick)
find_package(TreelandProtocols REQUIRED)
pkg_check_modules(EGL REQUIRED IMPORTED_TARGET egl gl)
qt_add_executable(test-capture
    main.cpp
)
qt_add_qml_module(test-capture
    URI capture
    VERSION 2.0
    SOURCES
    capture.h
    capture.cpp
    subwindow.h
    subwindow.cpp
    player.h
    player.cpp
    QML_FILES
    Main.qml
)

qt_add_resources(test-capture "test_capture_assets"
    PREFIX "/"
    BASE ${CMAKE_CURRENT_LIST_DIR}/images
    FILES
        ${CMAKE_CURRENT_LIST_DIR}/images/watermark.png
)

qt6_generate_wayland_protocol_client_sources(test-capture
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-capture-unstable-v1.xml
)

target_link_libraries(test-capture
    PRIVATE
        Qt6::Core
        Qt6::Gui
        Qt6::WaylandClient
        Qt6::WaylandClientPrivate
        Qt6::Quick
        Qt6::QuickPrivate
        Qt6::QuickControls2
        PkgConfig::EGL
)

install(TARGETS test-capture RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== examples/test_data_control_manager/CMakeLists.txt ===
set(BIN_NAME test_data_control_manager)

find_package(Qt6 REQUIRED COMPONENTS Core Gui WaylandClient)
find_package(PkgConfig REQUIRED)
pkg_check_modules(WLR_PROTOCOLS REQUIRED IMPORTED_TARGET wlr-protocols)
pkg_get_variable(WLR_PROTOCOLS_DATADIR wlr-protocols pkgdatadir)

qt_add_executable(${BIN_NAME}
    main.cpp
    clipboard.h
    clipboard.cpp
    datacontrolmanagerv1.h
    datacontrolmanagerv1.cpp
)

qt6_generate_wayland_protocol_client_sources(${BIN_NAME}
    FILES
        ${WLR_PROTOCOLS_DATADIR}/unstable/wlr-data-control-unstable-v1.xml
)

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Core
        Qt6::Gui
        Qt6::WaylandClient
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== examples/test_hide_window/CMakeLists.txt ===
find_package(Qt6 REQUIRED COMPONENTS Widgets)

set(BIN_NAME test-hide-window)

qt_add_executable(${BIN_NAME}
    main.cpp
)

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Widgets
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== examples/test_monitor_active_event/CMakeLists.txt ===
find_package(Qt6 REQUIRED COMPONENTS WaylandClient Widgets)
find_package(TreelandProtocols REQUIRED)

set(BIN_NAME test-monitor-active_event)

qt_add_executable(${BIN_NAME}
    main.cpp
)

qt_generate_wayland_protocol_client_sources(${BIN_NAME}
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-dde-shell-v1.xml
)

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Gui
        Qt6::Widgets
        Qt6::WaylandClient
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== examples/test_multitaskview/CMakeLists.txt ===
find_package(Qt6 REQUIRED COMPONENTS WaylandClient Quick)
find_package(TreelandProtocols REQUIRED)

set(BIN_NAME test-multitaskview)

qt_standard_project_setup(REQUIRES 6.5)

qt_add_executable(${BIN_NAME}
    main.cpp
)

qt_add_qml_module(${BIN_NAME}
    URI test.multitaskview
    VERSION 1.0
    QML_FILES
        Main.qml
    SOURCES
        ddeshell.h
        ddeshell.cpp
)

qt_generate_wayland_protocol_client_sources(${BIN_NAME}
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-dde-shell-v1.xml
)

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Quick
        Qt6::WaylandClient
        Qt6::WaylandClientPrivate
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== examples/test_primary_output/CMakeLists.txt ===
find_package(Qt6 REQUIRED COMPONENTS WaylandClient Widgets)
find_package(TreelandProtocols REQUIRED)

set(BIN_NAME test-primary-output)

qt_add_executable(${BIN_NAME}
    main.cpp
)

qt_generate_wayland_protocol_client_sources(${BIN_NAME}
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}treeland-output-manager-v1.xml
)

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Gui
        Qt6::Widgets
        Qt6::WaylandClient
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== examples/test_set_treeland_wallpaper/CMakeLists.txt ===
find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core)
find_package(Qt6 REQUIRED COMPONENTS WaylandClient Quick Core Gui)
find_package(Dtk6 REQUIRED COMPONENTS Declarative)
find_package(TreelandProtocols REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_get_variable(WAYLAND_PROTOCOLS wayland-protocols pkgdatadir)

set(BIN_NAME test-set-treeland-wallpaper)

qt_add_executable(${BIN_NAME}
    main.cpp
)

qt_generate_wayland_protocol_client_sources(${BIN_NAME}
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-personalization-manager-v1.xml
)

set(QML_FILES
    main.qml
    Wallpaper.qml
    WallpaperCard.qml
    WallpaperSetting.qml
    PropertyItemDelegate.qml
)

qt_add_qml_module(${BIN_NAME}
    URI Wallpaper
    VERSION "1.0"
    SOURCES
    personalizationmangerclient.cpp
    personalizationmangerclient.h
    wallpapercardmodel.cpp
    wallpapercardmodel.h
    QML_FILES ${QML_FILES}
    SOURCES imagehelper.h imagehelper.cpp
)

set(TRANSLATED_FILES)

qt_add_lupdate(
    SOURCE_TARGETS ${BIN_NAME}
    TS_FILES
        translations/wallpaper.zh_CN.ts
        translations/wallpaper.en_US.ts
    NO_GLOBAL_TARGET
)

qt_add_lrelease(
    TS_FILES
        translations/wallpaper.zh_CN.ts
        translations/wallpaper.en_US.ts
    QM_FILES_OUTPUT_VARIABLE TRANSLATED_FILES
)

install(FILES ${TRANSLATED_FILES} DESTINATION ${TREELAND_COMPONENTS_TRANSLATION_DIR})

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Gui
        Qt6::WaylandClient
        Dtk6::Declarative
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== examples/test_show_desktop/CMakeLists.txt ===
find_package(Qt6 REQUIRED COMPONENTS WaylandClient Widgets)
find_package(TreelandProtocols REQUIRED)

set(BIN_NAME test-show-desktop)

qt_add_executable(${BIN_NAME}
    main.cpp
)

qt_generate_wayland_protocol_client_sources(${BIN_NAME}
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-window-management-v1.xml
)

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Gui
        Qt6::Widgets
        Qt6::WaylandClient
        Qt6::GuiPrivate
        Qt6::WaylandClientPrivate
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== debian/changelog ===
treeland (0.5.20) unstable; urgency=medium

  * fix: activeColor not saved to dconfig
  * fix: send error output enter for layer shell
  * chore: input popup should not use radius

 -- rewine <luhongxu@deepin.org>  Mon, 10 Mar 2025 16:20:35 +0800

treeland (0.5.19) unstable; urgency=medium

  * fix: can't set output's postion
  * fix: layer shell's popup not enter popup container

 -- rewine <luhongxu@deepin.org>  Sat, 15 Feb 2025 15:30:10 +0800

treeland (0.5.18) unstable; urgency=medium

  * fix: the tooltip text may disappear unexpectedly
  * fix: can't start on VirtualBox
  * feat: cache outputs settings

 -- rewine <luhongxu@deepin.org>  Fri, 14 Feb 2025 10:31:38 +0800

treeland (0.5.17) unstable; urgency=medium

  * fix: nix ci for build
  * Fix missing treeland's translations

 -- Groveer <guoyao@uniontech.com>  Wed, 15 Jan 2025 11:02:18 +0800

treeland (0.5.16) unstable; urgency=medium

  * fix: crashed at accessing surface
  * Fix crash at QStyleHints

 -- zhangkun <zhangkun2@uniontech.com>  Tue, 14 Jan 2025 16:16:43 +0800

treeland (0.5.15) unstable; urgency=medium

  * chore: update default window corner size

 -- zhangkun <zhangkun2@uniontech.com>  Tue, 14 Jan 2025 11:45:30 +0800

treeland (0.5.14) unstable; urgency=medium

  * Fix crash at PersonalizationAttached::noTitlebar
  * Add a background color for DockPreview

 -- JiDe Zhang <zhangjide@uniontech.com> Mon, 13 Jan 2025 18:13:21 +0800

treeland (0.5.13) unstable; urgency=medium

  * feat: add ctrl-alt-del shortcut key
  * Add TREELAND_SESSION_ENVIRONMENTS env
  * fix: popup of screen recorder is below it's parent
  * Fix typo
  * Ignore window rounded radius when maximized

 -- JiDe Zhang <zhangjide@uniontech.com> Mon, 13 Jan 2025 11:02:32 +0800

treeland (0.5.12) unstable; urgency=medium

  * Fix maybe freeze when display DockPreview
  * feat: update default values
  * fix: adjust UI for greeter

 -- Groveer <guoyao@uniontech.com>  Wed, 08 Jan 2025 11:22:31 +0800

treeland (0.5.11) unstable; urgency=medium

  * bump version to 0.5.11

 -- Groveer <guoyao@uniontech.com>  Wed, 25 Dec 2024 18:47:45 +0800

treeland (0.5.10) unstable; urgency=medium

  * bump version to 0.5.10

 -- Groveer <guoyao@uniontech.com>  Fri, 20 Dec 2024 16:04:58 +0800

treeland (0.5.9) unstable; urgency=medium

  * bump version to 0.5.9

 -- Groveer <guoyao@uniontech.com>  Tue, 17 Dec 2024 21:04:15 +0800

treeland (0.5.8) unstable; urgency=medium

  * bump version to 0.5.8

 -- Groveer <guoyao@uniontech.com>  Fri, 13 Dec 2024 14:14:01 +0800

treeland (0.5.7) unstable; urgency=medium

  * bump version to 0.5.7

 -- Groveer <guoyao@uniontech.com>  Tue, 10 Dec 2024 18:29:02 +0800

treeland (0.5.6) unstable; urgency=medium

  * bump version to 0.5.6

 -- rewine <luhongxu@deepin.org>  Fri, 06 Dec 2024 15:05:05 +0800

treeland (0.5.5) unstable; urgency=medium

  * bump version to 0.5.5

 -- Groveer <guoyao@uniontech.com>  Thu, 05 Dec 2024 21:22:32 +0800

treeland (0.5.4) unstable; urgency=medium

  * bump version to 0.5.4

 -- Groveer <guoyao@uniontech.com>  Sat, 30 Nov 2024 15:52:51 +0800

treeland (0.5.3) unstable; urgency=medium

  * bump version to 0.5.3

 -- Groveer <guoyao@uniontech.com>  Fri, 29 Nov 2024 15:58:26 +0800

treeland (0.5.2) unstable; urgency=medium

  * bump version to 0.5.2

 -- Groveer <guoyao@uniontech.com>  Tue, 26 Nov 2024 15:01:56 +0800

treeland (0.5.1) unstable; urgency=medium

  * bump version to 0.5.1

 -- Groveer <guoyao@uniontech.com>  Fri, 22 Nov 2024 18:10:04 +0800

treeland (0.5.0) unstable; urgency=medium

  * bump version to 0.5.0

 -- Groveer <guoyao@uniontech.com>  Thu, 21 Nov 2024 17:02:20 +0800

treeland (0.4.4) unstable; urgency=medium

  * bump version to 0.4.4

 -- Groveer <guoyao@uniontech.com>  Fri, 15 Nov 2024 14:15:57 +0800

treeland (0.4.3) unstable; urgency=medium

  * bump version to 0.4.3

 -- Groveer <guoyao@uniontech.com>  Mon, 11 Nov 2024 19:10:14 +0800

treeland (0.4.1) unstable; urgency=medium

  * update appearance protocol

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Thu, 01 Nov 2024 11:20:00 +0800

treeland (0.4) unstable; urgency=medium

  * update workspace

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Thu, 01 Nov 2024 11:20:00 +0800

treeland (0.3) unstable; urgency=medium

  * support windows animation

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Thu, 25 Jul 2024 18:20:00 +0800

treeland (0.2.3) unstable; urgency=medium

  * refactor protocol from qml to c++

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Thu, 27 Jun 2024 14:27:40 +0800

=== waylib/debian/changelog ===
waylib (0.6.11) unstable; urgency=medium

  * bump version to 0.6.11

 -- rewine <luhongxu@deepin.org>  Fri, 14 Feb 2025 10:31:38 +0800

waylib (0.6.10) unstable; urgency=medium

  * bump version to 0.6.10

 -- Groveer <guoyao@uniontech.com>  Wed, 25 Dec 2024 18:45:12 +0800

waylib (0.6.9) unstable; urgency=medium

  * bump version to 0.6.9

 -- Groveer <guoyao@uniontech.com>  Fri, 20 Dec 2024 15:48:51 +0800

waylib (0.6.8) unstable; urgency=medium

  * bump version to 0.6.8

 -- Groveer <guoyao@uniontech.com>  Tue, 17 Dec 2024 21:01:39 +0800

waylib (0.6.7) unstable; urgency=medium

  * bump version to 0.6.7

 -- Groveer <guoyao@uniontech.com>  Fri, 13 Dec 2024 14:08:45 +0800

waylib (0.6.6) unstable; urgency=medium

  * bump version to 0.6.6

 -- Groveer <guoyao@uniontech.com>  Tue, 10 Dec 2024 18:26:33 +0800

waylib (0.6.5) unstable; urgency=medium

  * bump version to 0.6.5

 -- Groveer <guoyao@uniontech.com>  Thu, 05 Dec 2024 21:25:01 +0800

waylib (0.6.4) unstable; urgency=medium

  * bump version to 0.6.4

 -- Groveer <guoyao@uniontech.com>  Sat, 30 Nov 2024 15:21:56 +0800

waylib (0.6.3) unstable; urgency=medium

  * bump version to 0.6.3

 -- Groveer <guoyao@uniontech.com>  Fri, 29 Nov 2024 15:44:40 +0800

waylib (0.6.2) unstable; urgency=medium

  * bump version to 0.6.2

 -- Groveer <guoyao@uniontech.com>  Tue, 26 Nov 2024 18:48:43 +0800

waylib (0.6.1) unstable; urgency=medium

  * bump version to 0.6.1

 -- Groveer <guoyao@uniontech.com>  Fri, 22 Nov 2024 18:06:22 +0800

waylib (0.6.0) unstable; urgency=medium

  * bump version to 0.6.0

 -- Groveer <guoyao@uniontech.com>  Thu, 21 Nov 2024 17:00:46 +0800

waylib (0.5.0) unstable; urgency=medium

  * bump version to 0.5.0

 -- Groveer <guoyao@uniontech.com>  Thu, 14 Nov 2024 03:27:45 +0000

waylib (0.4.3) unstable; urgency=medium

  * bump version to 0.4.3

 -- Groveer <guoyao@uniontech.com>  Thu, 14 Nov 2024 03:26:56 +0000

=== waylib/qwlroots/debian/changelog ===
qwlroots (0.5.2) unstable; urgency=medium

  * bump version to 0.5.2

 -- Groveer <guoyao@uniontech.com>  Tue, 26 Nov 2024 18:55:56 +0800

qwlroots (0.5.1) unstable; urgency=medium

  * bump version to 0.5.1

 -- Groveer <guoyao@uniontech.com>  Fri, 22 Nov 2024 18:04:26 +0800

qwlroots (0.5.0) unstable; urgency=medium

  * bump version to 0.5.0

 -- Groveer <guoyao@uniontech.com>  Thu, 21 Nov 2024 16:58:34 +0800

qwlroots (0.4.1) UNRELEASED; urgency=medium

  * bump version to 0.4.1

 -- Groveer <guoyao@uniontech.com>  Mon, 11 Nov 2024 18:14:56 +0800

=== debian/control ===
Source: treeland
Priority: optional
Maintainer: rewine <luhongxu@deepin.org>
Build-Depends: cmake (>= 3.4~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 1.4.0~),
               libddm-dev,
               libdtk6core-dev,
               libdtk6declarative-dev,
               libdtk6gui-dev,
               libdtk6systemsettings-dev,
               libdtkcommon-dev,
               libsystemd-dev [linux-any],
               systemd,
               libwaylib-dev,
               libwlroots-0.18-dev,
               pkg-config,
               qt6-base-dev (>= 6.6.1~),
               qt6-base-private-dev (>= 6.6.1~),
               qt6-declarative-dev (>= 6.6.1~),
               qt6-shadertools-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools (>= 6.6.1~),
               qt6-wayland,
               qt6-wayland-dev,
               qt6-wayland-private-dev,
               qwlroots,
               wlr-protocols,
               treeland-protocols,
               libpam0g-dev,
               libjemalloc-dev,
Standards-Version: 4.6.0
Section: dde
Homepage: https://github.com/linuxdeepin/treeland.git
#Vcs-Browser: https://salsa.debian.org/debian/treeland
#Vcs-Git: https://salsa.debian.org/debian/treeland.git
Rules-Requires-Root: no

Package: treeland
Section: dde
Architecture: any
Multi-Arch: same
Depends: qml6-module-qtquick-layouts,
         qml6-module-qtquick-particles,
         treeland-data (= ${source:Version}),
         xwayland,
         ${shlibs:Depends},
Description: a Wayland compositor based on wlroots and QML, designed with an attractive and elegant appearance.

Package: treeland-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, treeland( =${source:Version}),
Description: a Wayland compositor based on wlroots and QML, designed with an attractive and elegant appearance.

Package: treeland-examples
Section: dde
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
Description: examples for treeland.

Package: treeland-data
Section: dde
Architecture: all
Depends: ${misc:Depends},
Description: data files of treeland.

Package: treeland-wayland-session
Section: dde
Architecture: all
Depends: ${misc:Depends},
         treeland (= ${source:Version}),
Description: treeland user session files of treeland.

=== waylib/debian/control ===
Source: waylib
Section: libdevel
Priority: optional
Maintainer: JiDe Zhang <zhangjide@deepin.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libpixman-1-dev,
               libwlroots-0.18-dev,
               libxcb-ewmh-dev,
               pkg-config,
               qml6-module-qtquick-templates,
               qt6-base-dev-tools (>= 6.6.0),
               qt6-base-private-dev (>= 6.6.0),
               qt6-declarative-private-dev (>= 6.6.0),
               qwlroots,
               wayland-protocols,
               wlr-protocols,
Standards-Version: 3.9.8

Package: libwaylib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Multi-Arch: same
Description:  A wrapper for wlroots based on Qt
 .
 This package contains the shared libraries.

Package: libwaylib-dev
Architecture: any
Depends: libwaylib (=${binary:Version}),
         libwlroots-0.18-dev,
         qt6-base-dev-tools (>= 6.6.0),
         qt6-base-private-dev (>= 6.6.0),
         qt6-declarative-private-dev (>= 6.6.0),
         wlr-protocols,
         ${misc:Depends},
         ${shlibs:Depends},
Description: A devel package for libwaylib
 .
 This package contains the header files and static libraries of waylib.

=== waylib/qwlroots/debian/control ===
Source: qwlroots
Priority: optional
Maintainer: rewine <lhongxu@outlook.com>
Build-Depends: debhelper-compat (= 13),
               pkg-config,
               cmake,
               qt6-base-private-dev,
               qt6-base-dev-tools,
               wayland-protocols,
               wlr-protocols,
               libwlroots-0.18-dev,
               libpixman-1-dev,
               libxcb-ewmh-dev,
               libdrm-dev
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/vioken/qwlroots.git
#Vcs-Browser: https://salsa.debian.org/debian/qwlroots
#Vcs-Git: https://salsa.debian.org/debian/qwlroots.git
Rules-Requires-Root: no

Package: qwlroots
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libwlroots-0.18-dev
Replaces: libqwlroots1
Description: Qt and QML bindings for wlroots
  qwlroots is a binding of wlroots, which provides a Qt style development interface.
 It aims to simplify wlroots API calling methods with Qt, and serve the needs of
 calling wlroots within Qt projects.
 .
 This package contains the development headers and static library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

TREELAND_CMAKE_ARGS = -DBUILD_TREELAND_EXAMPLES=ON

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- ${TREELAND_CMAKE_ARGS}

=== waylib/qwlroots/debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
   https://github.com/vioken/qwlroots/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
